#include<stdio.h>
#include<stdlib.h>
#include "cquad.h"

double fun(double x);

int main()
{
 double bound, epsabs, epsrel, result, abserr, *work;
 int neval, ier, inf, last, *iwork;

 // bound and inf determine the integration limits
    bound = 0.0;
    inf = 1;

 // epsabs and epsrel determine the accuracy requirement    
    epsabs = 0.0;
    epsrel = 0.001;

 // allocate memory
    iwork = (int *) calloc(LIMIT, sizeof(int));
    work = (double *) calloc(LENW, sizeof(double));

    result = cquad_dqagi(fun, bound, inf, epsabs, epsrel, &abserr, &neval, &ier, &last, iwork, work);

 // print the result
    printf("\nFunction:  log(x) / (1 + 100x²)  over [0, +inf]\n");
    printf("\nIntegral approximation:           %lg\n", result);
    printf("Estimate of absolute error:        %lg\n", abserr);
    printf("Number of function evaluations:    %d\n", neval);
    printf("Error code:  %d\n\n", ier);

 // free allocated memory 
    free(iwork);
    free(work);
}
