#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "cquad.h"

double fun(double x);

int main()
{
    double a, b, epsabs, epsrel, result, abserr, *points, *work;
    int neval, ier, npts2, last, *iwork;

 // a and b are the integration limits
    a = 0.0;
    b = 3.0;

 // points[i], i = 0, ..., npts2 - 3 are the abscissae where a difficulty 
 // of the integrand is situated

    npts2 = 4;
    points = (double *) calloc(npts2, sizeof(double));
    points[0] = 1.0;
    points[1] = sqrt(2.0);

 // epsabs and epsrel determine the accuracy requirement    
    epsabs = 0.0;
    epsrel = 0.001;

 // allocate memory
    iwork = (int *) calloc(LENIW, sizeof(int));
    work = (double *) calloc(LENW, sizeof(double));

    result = cquad_dqagp(fun, a, b, npts2, points, epsabs, epsrel, &abserr, &neval, &ier, &last, iwork, work);
 
 // print the result
    printf("\nFunction:  x³ * log|(x²-1)(x²-2)|  over [0, 3]\n");
    printf("\nIntegral approximation:           %lg\n", result);
    printf("Estimate of absolute error:        %lg\n", abserr);
    printf("Number of function evaluations:    %d\n", neval);
    printf("Error code:  %d\n\n", ier);

 // free allocated memory
    free(points); 
    free(iwork);
    free(work);
}
