#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "cquad.h"

double fun(double x);

int main()
{
    double a, b, c, epsabs, epsrel, result, abserr, *work;
    int neval, ier, last, *iwork;

 // a and b are the integration limits
    a = - 1.0;
    b = 5.0;

 // c is the parameter of the weight function
    c = 0.0;

 // epsabs and epsrel determine the accuracy requirement
    epsabs = 0;
    epsrel = 0.001;

 // allocate memory
    iwork = (int *) calloc(LIMIT, sizeof(int));
    work = (double *) calloc(LENW, sizeof(double));

    result = cquad_dqawc(fun, a, b, c, epsabs, epsrel, &abserr, &neval, &ier, &last, iwork, work);
 
 // print the result
    printf("\nFunction:  dx / (x(5x³ + 6))  over [-1, 5]\n");
    printf("\nIntegral approximation:           %lg\n", result);
    printf("Estimate of absolute error:        %lg\n", abserr);
    printf("Number of function evaluations:    %d\n", neval);
    printf("Error code:  %d\n\n", ier);

 // free allocated memory 
    free(iwork);
    free(work);
}
