#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "cquad.h"

double fun(double x);

int main()
{
    double a, b, epsabs, epsrel, result, abserr, omega, *work;
    int neval, ier, integr, last, *iwork;

 // a and b are the integration limits
    a = 0.0;
    b = 1.0;

 // omega and integr determine the weight function
    omega = M_PI * 10.0;
    integr = 2;

 // epsabs and epsrel determine the accuracy requirement    
    epsabs = 0.0;
    epsrel = 0.001;

 // allocate memory
    iwork = (int *) calloc(LENIW, sizeof(int));
    work = (double *) calloc(LENW, sizeof(double));

    result = cquad_dqawo(fun, a, b, omega, integr, epsabs, epsrel, &abserr, &neval, &ier, &last, iwork, work);

 // print the result
    printf("\nFunction:  log(x) * sin(10x)  over [0, 1]\n");
    printf("\nIntegral approximation:           %lg\n", result);
    printf("Estimate of absolute error:        %lg\n", abserr);
    printf("Number of function evaluations:    %d\n", neval);
    printf("Error code:  %d\n\n", ier);

 // free allocated memory 
    free(iwork);
    free(work);
}
